<?php

if (!version_compare(phpversion(), '5.3.0', '>='))
    die("This software requires PHP version 5.3.0 at least, yours is ".phpversion());

if (!class_exists('SQLite3'))
    die("This software requires the SQLite3 PHP extension, and it can't be found on this system!");


$db = new SQLite3('database.db');
$db->busyTimeout(15000);
// initial DB
$db->querySingle('CREATE TABLE IF NOT EXISTS database (
	id INTEGER PRIMARY KEY,
	created_at INT,
	updated INT,
	author TEXT,
	file_url TEXT,
	file_url_local TEXT,
	file_url_local_thumbnail TEXT,
	tags TEXT,
	tags_character TEXT,
	tags_work TEXT,
	tags_artist TEXT,
	source TEXT,
	rating TEXT,
	score INT,
	format TEXT,
	width INT,
	height INT,
	file_size INT,
	checksum TEXT,
	checksum_sha1 TEXT
       )'
); 


// new item insertion or item update (tags, rating, score..)  - data is supposed clean
function insertOrUpdate($id, $created_at, $updated, $author, $file_url, $file_url_local, $file_url_local_thumbnail, $tags, $tags_character, $tags_work, $tags_artist, $source, $rating, $score, $format, $width, $height, $file_size, $checksum, $checksum_sha1)
{
 $db = new SQLite3('database.db');
 $exists = $db->querySingle('SELECT * FROM database WHERE id = \''.$id.'\';', true);
 if (empty($exists))
  {
  $db->exec("INSERT INTO database (id, created_at, updated, author, file_url, file_url_local, file_url_local_thumbnail, tags, tags_character, tags_work, tags_artist, source, rating, score, format, width, height, file_size, checksum, checksum_sha1) VALUES ('$id', '$created_at', '$updated', '$author', '$file_url', '$file_url_local', '$file_url_local_thumbnail', '$tags', '$tags_character', '$tags_work', '$tags_artist', '$source', '$rating', '$score', '$format', '$width', '$height', '$file_size', '$checksum', '$checksum_sha1');");
  }
 else
  {
  $db->exec("UPDATE database SET updated='$updated', tags='$tags', tags_character='$tags_character', tags_work='$tags_work', tags_artist='$tags_artist', rating='$rating', score='$score' WHERE id = '$id';");
  }
}

// item retrieval from the database
function getDataId($id)
{
 $db = new SQLite3('database.db');
 $exists = $db->query('SELECT * FROM database WHERE id = \''.$id.'\';');
 if (empty($exists) or $exists == FALSE)
  {
  return FALSE;
  }
 else
  {
  $out = array();
  while ($row = $exists->fetchArray(SQLITE3_ASSOC))
   {
   $out[] = $row;
   }
  return $out;
  }
}

// item search from the database
function searchDatabase($query, $page = 1)
{
 $db = new SQLite3('database.db');
        $nb = 20;
        $begin = ($page - 1) * $nb;
 $res = $db->query('SELECT *
            FROM database
            WHERE author LIKE \'%'.$query.'%\'
            OR tags LIKE \'%'.$query.'%\'
            OR tags_character LIKE \'%'.$query.'%\'
            OR tags_work LIKE \'%'.$query.'%\'
            OR tags_artist LIKE \'%'.$query.'%\'
            ORDER BY id DESC
            LIMIT '.(int)$begin.','.(int)$nb.';');

 $out = array();

 while ($row = $res->fetchArray(SQLITE3_ASSOC))
  {
  $out[] = $row;
  }

  return $out;
}

// fetch items for 1 page
function listByPage($page = 1)
{
 $db = new SQLite3('database.db');
        $nb = 20;
        $begin = ($page - 1) * $nb;
        $res = $db->query('SELECT * FROM database ORDER BY id DESC LIMIT '.(int)$begin.','.(int)$nb.';');

        $out = array();

        while ($row = $res->fetchArray(SQLITE3_ASSOC))
        {
            $out[] = $row;
        }

        return $out;
}

// full database output
function fullDump()
{
 $db = new SQLite3('database.db');
        $res = $db->query('SELECT * FROM database ORDER BY id DESC;');
        $out = array();
        while ($row = $res->fetchArray(SQLITE3_ASSOC))
        {
            $out[] = $row;
        }

        return $out;
}

// count number of rows (information)
function countrows($query='')
{
 $db = new SQLite3('database.db');
        $res = $db->querySingle('SELECT COUNT(*) FROM database WHERE author LIKE \'%'.$query.'%\'
            OR tags LIKE \'%'.$query.'%\'
            OR tags_character LIKE \'%'.$query.'%\'
            OR tags_work LIKE \'%'.$query.'%\'
            OR tags_artist LIKE \'%'.$query.'%\'
            ;');
         return $res;
}

// find the item with highest id
function newestrow()
{
 $db = new SQLite3('database.db');
        $res = $db->querySingle('SELECT id FROM database ORDER BY id DESC LIMIT 0,1;');
         return $res;
}

// find the item with lowest id
function oldestrow()
{
 $db = new SQLite3('database.db');
        $res = $db->querySingle('SELECT id FROM database ORDER BY id ASC LIMIT 0,1;');
         return $res;
}


?>
