<?php

function blacklistIdCheck($id, $reset = FALSE) { // let's check if id is known blacklisted
 $folder = str_pad(substr($id, 0, -3), 3, '0', STR_PAD_LEFT);
 if($reset == TRUE) {unlink("./img/$folder/$id.404"); return FALSE;}
 if(file_exists("./img/$folder/$id.404")) return filemtime("./img/$folder/$id.404"); // return filemodtime so we can do re-check after expire
 else return FALSE;
}

function blacklistId($id) { // ok id let's blacklist the id
 $folder = str_pad(substr($id, 0, -3), 3, '0', STR_PAD_LEFT);
 if(file_exists("./img/$folder")) { } else { mkdir("./img/$folder", 0755, TRUE); }
 file_put_contents("./img/$folder/$id.404", '');
}

function image_fetcher($url, $remote_page, $id, $format, $modtime, $checksum) {

$json=array();

 $xcontext = stream_context_create(array("http"=>array("header"=>"Referer: ".$remote_page."\r\n"))); //yep, we cheat the referer since some of them use heavy anti-hotlink protection
 $content = file_get_contents($url,false,$xcontext);
 if ($content === false) { $json['status'].= 'Couldn\'t download the file. Sorry.'; }
 $test = file_put_contents("./$id.$format",$content);
 if ($test === false) { $json['status'].= 'Couldn\'t save the file. Sorry.'; }

 // additional metadata
 $file_size = filesize("./$id.$format");
 $getimagesize = getimagesize("./$id.$format"); $width = $getimagesize['0']; $height = $getimagesize['1']; 

 if($checksum !== FALSE)
  {
  // optional checksum processing if the remote provides it
  if(strlen($checksum) == 32)
   { $checksumtest = md5_file("./$id.$format"); }
  else
   { $checksumtest = sha1_file("./$id.$format"); }
	
  if ($checksumtest == $checksum) { }
  else { unlink("./$id.$format"); $json['status'].= "checksum mismatch: got local $checksumtest while remote has $checksum"; }
  }

// get the folder name from the id. (for example id "7942" would be in folder "007")
$folder = str_pad(substr($id, 0, -3), 3, '0', STR_PAD_LEFT);

// folder tree and image moving
if(file_exists("./img/$folder")) { } else { mkdir("./img/$folder", 0755, TRUE); }
if(file_exists("./thumb/$folder")) { } else { mkdir("./thumb/$folder", 0755, TRUE); }
 if (copy("./$id.$format","./img/$folder/$id.$format")) { unlink("$id.$format"); } else { unlink("./$id.$format"); $json['status'].= "can't move file in the proper folder; permissions ?"; return json_encode($json); }

// image modtime
 touch("./img/$folder/$id.$format", $modtime);

 // thumbnail generation
 if($format=='jpg') $im = imagecreatefromjpeg("./img/$folder/$id.$format");
 else if($format=='png') $im = imagecreatefrompng("./img/$folder/$id.$format");
 else if($format=='gif') $im =  imagecreatefromgif("./img/$folder/$id.$format");
 else if($format=='webp') $im =  imagecreatefromwebp("./img/$folder/$id.$format");
 else $json['status'].= "improper format detected, can't create thumbnail";
  $newheight = 200;
  $ratio_orig = $width/$height;
  $newwidth = $newheight*$ratio_orig;
 $tmp_img = imagecreatetruecolor($newwidth, $newheight);
 imagecopyresampled($tmp_img, $im, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
  if($format=='gif') // little watermark for GIF images (since the output thumbnail isn't animated)
   {
   $textcolor = imagecolorallocate($tmp_img, 255, 0, 0);$bgcolor = imagecolorallocate($tmp_img, 255, 255, 255);
   imagefilledrectangle($tmp_img, 0, 0, 30, 20, $bgcolor);
   imagestring($tmp_img, 6, 2, 1, 'GIF', $textcolor);
   }
 imageinterlace($tmp_img, true);
 imagejpeg($tmp_img, "./thumb/$folder/$id.jpg", 60);
 imagedestroy($im);
 imagedestroy($tmp_img);

// status processing; if everything's ok, output the data
if(!isset($json['status']) or empty($json['status']))
 {
  $checksum = md5_file("./img/$folder/$id.$format");
  $checksum_sha1 = sha1_file("./img/$folder/$id.$format");
 $json['status'] = 'ok';
 $json['file_size'] = $file_size;
 $json['width'] = $width;
 $json['height'] = $height;
 $json['checksum'] = $checksum;
 $json['checksum_sha1'] = $checksum_sha1;
 $json['file_url_local'] = "./img/$folder/$id.$format";
 $json['file_url_local_thumbnail'] = "./thumb/$folder/$id.jpg";


 }
 else $json = array('status'=>'general error, discarding');

return json_encode($json);

}


?>
